.nolist
#include "ion.inc"
.list
#ifdef TI83P
  .org    progstart-2
  .db     $BB,$6D
#else
  .org    progstart
#endif
  ret				
  jr      nc,The_Urinal_Game
  .db     "The Urinal Game - BASM",0

level    = SafeRam1
selected = SafeRam1+1
wait     = SafeRam1+2
wr       = SafeRam1+4

#define     equ             .equ
#define     EQU             .equ

_SFont_Len	EQU 4786h
_SStringLength	EQU 4CB4h
_ClearRect	EQU 4D5Ch

The_Urinal_Game:

  xor  a
  ld   (level),a
  set  textWrite,(IY+sGrFlags)

  ld   hl,TitleText
  call TitleAndText
WaitForAnyKey:
  bcall(_GetCSC)
  cp   skClear
  ret  z
  or   a
  jr   z,WaitForAnyKey

New_Level:
  xor  a
  ld   (selected),a
New_Level2:
  bcall(_GrBufClr)
  ld   a,(level)
  add  a,a
  ld   c,a
  add  a,a
  add  a,c
  ld   d,0
  ld   e,a
  ld   hl,level1
  add  hl,de
  ld   b,6
  ld   a,1
Put_Level:
  push bc
  push hl
  push af
  ld   a,(hl)
  or   a
  jr   z,Put_Level3
  dec  a
  add  a,a          ;2a
  add  a,a          ;4a
  add  a,a          ;8a
  add  a,a          ;16a
  add  a,a          ;32a
  add  a,a          ;64a
  ld   e,a
  ld   d,0
  ld   ix,man1
  add  ix,de
  pop  af
  push af
  ld   l,0
  ld   b,32
  ld   c,2
  call ionLargeSprite
Put_Level2:
  pop  af
  add  a,13
  pop  hl
  inc  hl
  pop  bc
  djnz Put_Level  
  jr   Done_Level  
Put_Level3:
  pop  af
  push af
  ld   b,18
  ld   c,2
  ld   l,8
  ld   ix,urinal
  call ionLargeSprite
  jr   Put_Level2
Done_Level:

  ld   l,0
  ld   a,79
  ld   c,2
  ld   b,32
  ld   ix,door
  call ionLargeSprite

PutLevelText:
  ld   hl,Level1_Open
  ld   a,(level)
  call MultiplyABy10
  or   a
  jr   z,PutLevelText3
  ld   b,a
PutLevelText2:
  call FindZero
  djnz PutLevelText2
PutLevelText3:
  call CenterText
  ld   a,33
  ld   (penRow),a
  bcall(_vputs)
  call CenterText
  ld   a,40
  ld   (penRow),a
  bcall(_vputs)

  call XorRow32

  ld   a,(selected)
  ld   c,a
  add  a,a ;2a
  add  a,a ;4a
  ld   b,a
  add  a,a ;8a
  add  a,b ;12a
  add  a,c ;13a
  cp   78
  call z,Put4Xor
  ld   l,0
  ld   b,32
  ld   c,2
  ld   ix,XorData14
  call ionLargeSprite
  call ionFastCopy

KeyLoop:
  bcall(_GetCSC) 
  cp   skLeft
  jp   z,MoveLeft
  cp   skRight
  jp   z,MoveRight
  cp   skClear
  ret  z
  cp   sk2nd
  jr   nz,KeyLoop 

  call ClearTextArea

  ld   a,(level)
  add  a,a
  ld   b,a
  add  a,a
  add  a,b
  ld   d,0
  ld   e,a
  ld   hl,level1
  add  hl,de
  ld   a,(selected)
  ld   b,a
  cp   6
  jp   z,DoorText
  ld   d,0
  ld   e,a
  add  hl,de
  ld   a,(hl)
  or   a
  jp   nz,WhoaDude
  ld   a,(level)
  ld   d,0
  ld   e,a
  ld   hl,answer
  add  hl,de
  ld   a,(hl)
  cp   b
  jr   z,Correct
Wrong:
  ld   a,1
  ld   (wr),a
  ld   a,(level)
  call MultiplyABy10
  add  a,6
  jr   PutLevelTexts
Correct:
  xor  a
  ld   (wr),a
  ld   a,(level)
  call MultiplyABy10
  add  a,2
PutLevelTexts:
  ld   hl,Level1_Open
  ld   b,a
PutLevelTexts2:
  call FindZero
  djnz PutLevelTexts2
  ld   b,4
  ld   d,33
PutTexts:
  push bc
  push de
  ld   a,d
  ld   (penRow),a
  Call CenterText
  bcall(_VPutS)
  pop  de
  ld   a,d
  add  a,7
  ld   d,a
  pop  bc
  djnz PutTexts
  call ionFastCopy
  ld   hl,plotSScreen
  ld   de,SafeRam1+5
  ld   bc,32*12
  ldir
  call PutWrongOrRight
WaitForKey:
  ld   hl,(wait)
  ld   de,1001
  bcall(_cphlde)
  call z,PutRegular
  ld   hl,(wait)
  ld   de,4001
  bcall(_cphlde)
  call z,PutWrongOrRight
  ld   hl,(wait)
  inc  hl
  ld   (wait),hl
  bcall(_getcsc)
  or   a
  jr   z,WaitForKey
  xor  a
  ld   (selected),a
  ld   a,(level)
  cp   5
  jr   z,done
  inc  a
  ld   (level),a
  jp   New_Level2

WhoaDude:
  ld   hl,Whoa
PutSpecialTexts:
  ld   b,3
  ld   d,33
PutTexts2:
  push bc
  push de
  ld   a,d
  ld   (penRow),a
  Call CenterText
  bcall(_VPutS)
  pop  de
  ld   a,d
  add  a,7
  ld   d,a
  pop  bc
  djnz PutTexts2
  call ionFastCopy
  jp   KeyLoop 
DoorText:
  ld   a,(level)
  cp   5
  jp   z,DoorText2
  ld   hl,TryToLeave
  jr   PutSpecialTexts
DoorText2:
  ld   a,(selected)
  cp   6
  jp   z,Correct
  jp   Wrong

done:
  bcall(_grbufclr)
  ld   hl,FinalText
  call TitleAndText
WaitForAnyKeyExit:
  bcall(_GetCSC)
  or   a
  jr   z,WaitForAnyKeyExit
  ret
  
MoveLeft:
  ld   a,(selected)
  or   a
  jr   nz,$+4
  add  a,7
  dec  a
  ld   (selected),a
  jp   New_Level2

MoveRight:
  ld   a,(selected)
  cp   6
  jr   nz,$+4
  ld   a,-1
  inc  a
  ld   (selected),a
  jp   New_Level2

Put4Xor:
  push af
  add  a,10
  ld   l,0
  ld   b,32
  ld   ix,XorData4
  call ionPutSprite
  pop  af
  ret

XorRow32:
  ld   hl,plotSScreen+(32*12)
  ld   b,12
XorRow322:
  ld   a,(hl)
  cpl
  ld   (hl),a
  inc  hl
  djnz XorRow322
  ret

ClearTextArea:
  ld   hl,33*256+0
  ld   de,63*256+95
  res  plotLoc,(IY+plotFlags)
  bcall(_ClearRect)
  set  plotLoc,(IY+plotFlags)
  ret

FindZero:
  ld   a,(hl)
  inc  hl
  or   a
  jr   nz,FindZero
  ret  

MultiplyABy10:
  add  a,a ;2a
  ld   c,a
  add  a,a ;4a
  add  a,a ;8a
  add  a,c ;10a
  ret

MoveOver:
  ld   b,32
  ld   de,12
MoveOver2:
  push hl
  push bc
  push de
  ld   b,d
  ld   c,e
  ld   de,plotSScreen
  ldir
  call ionFastCopy
  pop  de
  ld   hl,12
  add  hl,de
  ex   de,hl
  pop  bc
  pop  hl
  push de
  ld   de,12
  sbc  hl,de
  pop  de
  djnz MoveOver2
  ret
PutRegular:
  ld   hl,SafeRam1+5+(31*12)
  jr   MoveOver
PutWrongOrRight:
  ld   hl,0
  ld   (wait),hl
  ld   hl,WrongSprite+(31*12)
  ld   a,(wr)
  or   a
  jr   nz,$+5
  ld   hl,CorrectSprite+(31*12)
  jr   MoveOver

TitleAndText:
  ld   b,4
  ld   d,33
TitleAndText2:
  push bc
  push de
  ld   a,d
  ld   (penRow),a
  Call CenterText
  bcall(_VPutS)
  pop  de
  ld   a,d
  add  a,7
  ld   d,a
  pop  bc
  djnz TitleAndText2
  call XorRow32
  ld   hl,TitleSprite
  ld   de,plotSScreen
  ld   bc,32*12
  ldir
  call ionFastCopy
  ret

CenterText:
 ld   b,0
 push hl
CenterText2
 ld   a,(hl)        
 or   a
 jr   z,DoneCentering
 push hl    
 ld   l,a
 ld   h,0
 add  hl,hl
 add  hl,hl
 add  hl,hl
 push bc
 bcall(_SFont_Len)
 pop  af
 add  a,b
 ld   b,a
 pop  hl
 inc  hl
 jr   CenterText2
DoneCentering:
 ld   a,96
 sub  b
 sra  a
 ld   (penCol),a
 pop  hl
 ret

#include "keys.inc"
#include "text.inc"
#include "data.inc"
.end
END